---
title: Window.requestFileSystem()
slug: Web/API/Window/requestFileSystem
tags:
  - API
  - Deprecated
  - File
  - File System
  - File System API
  - File and Directory Entry API
  - Files
  - Method
  - Non-standard
  - Reference
  - Window
  - filesystem
  - requestFileSystem
---
<p>{{APIRef("File System API")}}{{non-standard_header()}}</p>

<p>The non-standard {{domxref("Window")}} method <strong><code>requestFileSystem()</code></strong> method is a Google Chrome-specific method which lets a web site or app gain access to a sandboxed file system for its own use. The returned {{domxref("FileSystem")}} is then available for use with the other <a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">file system APIs</a>.</p>

<div class="warning">
<p>Even compared to the rest of the File and Directory Entries API, <code>requestFileSystem()</code> is especially non-standard; only Chrome implements it, and all other browser makers have decided that they will not implement it. It has even been removed from <a href="https://wicg.github.io/entries-api/">the proposed specification</a>. <em>Do not use this method!</em></p>
</div>

<h2 id="Syntax">Syntax</h2>

<div class="note">
<p>This method is prefixed with <code>webkit</code> in all browsers that implement it (that is, Google Chrome).</p>
</div>

<pre class="syntaxbox">window.requestFileSystem(<em>type</em>, <em>size</em>, <em>successCallback</em>[, <em>errorCallback</em>]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>type</code></dt>
 <dd>The type of storage to request. Specify <code>Window.TEMPORARY</code> if it's acceptable for the browser to delete the files at its own discretion, such as if storage space runs low, or <code>Window.PERSISTENT</code> if you need the files to remain in place unless the user or the web site or app explicitly permit it. Persistent storage requires that the user grant the site quota.</dd>
 <dt><code>size</code></dt>
 <dd>The amount of storage space you wish to have allocated for your app's use.</dd>
 <dt><code>successCallback</code></dt>
 <dd>A function which is invoked when the file system has been successfully obtained. The callback receives a single parameter: a {{domxref("FileSystem")}} object representing the file system the app has permission to use.</dd>
 <dt><code>errorCallback</code> {{optional_inline}}</dt>
 <dd>An optional parameter specifying a function which is called if an error occurs while attempting to obtain the file system, or if the user denies permission to create or access the file system. The callback receives as input a single parameter: a {{domxref("FileError")}} object describing the error.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code></p>

<h2 id="Example">Example</h2>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('File System API')}}</td>
   <td>{{Spec2('File System API')}}</td>
   <td>Draft of proposed API</td>
  </tr>
 </tbody>
</table>

<p>This API has no official W3C or WHATWG specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.requestFileSystem")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Firefox_support">File and Directory Entries API support in Firefox</a></li>
</ul>
